routes/web.php
<?php

use App\Http\Controllers\AdminController;
use App\Http\Controllers\CityController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::prefix('cms/admin')->group(function(){
    Route::view('/', 'cms.parent');
    Route::view('/dasboard', 'cms.dashboard')->name('cms.dashboard');
    Route::view('/fathers/index', 'cms.fathers.index')->name('cms.fathers.index');
    Route::view('/tables', 'cms.samples.simple');
    Route::view('/forms', 'cms.samples.general');
    Route::view('/advanced', 'cms.samples.advanced');
    Route::resource('cities', CityController::class);
    Route::resource('admins', AdminController::class);
});

app/Models/City.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class City extends Model
{
    use HasFactory;

    public function getStatusAttribute()
    {
        return $this->active ? 'Active' : 'Not Active';
    }

    public function admins()
    {
        // return $this->hasMany(Admin::class);
        return $this->hasMany(Admin::class, 'city_id', 'id');

    }
}

app/Http/Controllers/CityController.php
<?php

namespace App\Http\Controllers;

use App\Models\City;
use Illuminate\Http\Request;

class CityController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //$cities = City::all();
        $cities = City::withCount('admins')->paginate(10);
        return response()->view('cms.cities.index',['cities' => $cities]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return response()->view('cms.cities.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required|string|min:3|max:30',
            'active' => 'in:on'
        ], [
            'name.required' => 'City name is required!',
            'name.min' => 'Name must be at least 3 characters'
        ]);
        $city = new City();
        $city->name = $request->get('name');
        $city->active = $request->has('active');
        $isSaved = $city->save();
        if($isSaved){
            session()->flash('message', 'City created successfully');
            return redirect()->route('cities.create');
        }else {

        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $city = City::findorfail($id);
        return response()->view('cms.cities.edit', ['city' => $city]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'name' => 'required|string|min:3|max:30',
            'active' => 'in:on'
        ]);
        
        $city = City::findOrFail($id);
        $city->name = $request->get('name');
        $city->active = $request->has('active');
        $isUpdated = $city->save();
        if($isUpdated){
            session()->flash('message', 'City Updated Successfully');
            session()->flash('alert-type', 'alert-success');
            session()->flash('check-circle', 'fa-check-circle');
            return redirect()->back();
        } else {
            session()->flash('message', 'Fail to updated City');
            session()->flash('alert-type', 'alert-danger');
            session()->flash('check-circle', 'fa-times');
        }
        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $isDeleted = City::destroy($id);
        if ($isDeleted) {
            return response()->json(['title' => 'Deleted!', 'message' => 'City Deleted Successfully', 'icon' => 'success'],200);
        } else {
            return response()->json(['title' => 'failed!', 'message' => 'Delete city failed', 'icon' => 'error'],400);
        }
        
        
    }
}

resources/views/cms/cities/create.blade.php
@extends('cms.parent')

@section('title', 'CreateCity')


@section('page-name', 'Create City')
@section('main-page', 'Cities')
@section('sub-page', 'Create City')

@section('content')

  <!-- Main content -->
  <section class="content">
    <div class="container-fluid">
      <div class="row">
        <!-- left column -->
        <div class="col-md-12">
          <!-- general form elements -->
          <div class="card card-primary">
            <div class="card-header">
              <h3 class="card-title">Create City</h3>
            </div>
            <!-- /.card-header -->
            <!-- form start -->
            <form role="form" method="POST" action="{{ route('cities.store') }}">
              @csrf
              <div class="card-body">
                @if ($errors->any())
                  <div class="alert alert-danger alert-dismissible">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h5><i class="icon fas fa-ban"></i> Validation Error!</h5>
                    @foreach ($errors->all() as $error)
                      <li>{{ $error }}</li>
                    @endforeach
                  </div>
                @endif
                @if (session()->has('message'))
                  <div class="alert alert-success alert-dismissible">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h5><i class="icon fas fa-check-circle"></i> {{ session('message') }}</h5>
                  </div>
                @endif
                <div class="form-group">
                  <label for="name">Name</label>
                  <input type="text" class="form-control" value="{{ old('name') }}" name="name" id="name"
                    placeholder="Enter City Name">
                </div>
                <div class="form-group">
                  <div class="custom-control custom-switch">
                    <input type="checkbox" class="custom-control-input" name="active" id="active">
                    <label class="custom-control-label" for="active">Active Status</label>
                  </div>
                </div>
              </div>
              <!-- /.card-body -->
              <div class="card-footer">
                <button type="submit" class="btn btn-primary">Submit</button>
              </div>
            </form>
          </div>
          <!-- /.card -->
        </div>
        <!--/.col (left) -->
      </div>
      <!-- /.row -->
    </div><!-- /.container-fluid -->
  </section>
  <!-- /.content -->

@endsection

@section('scripts')

  <script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
  <script type="text/javascript">
    $(document).ready(function() {
      bsCustomFileInput.init();
    });

  </script>

@endsection

resources/views/cms/cities/edit.blade.php
@extends('cms.parent')

@section('title', 'EditCity')


@section('page-name', 'Edit City')
@section('main-page', 'Cities')
@section('sub-page', 'Edit City')

@section('content')

  <!-- Main content -->
  <section class="content">
    <div class="container-fluid">
      <div class="row">
        <!-- left column -->
        <div class="col-md-12">
          <!-- general form elements -->
          <div class="card card-primary">
            <div class="card-header">
              <h3 class="card-title">Edite City</h3>
            </div>
            <!-- /.card-header -->
            <!-- form start -->
            <form role="form" method="POST" action="{{ route('cities.update', $city->id) }}">
              @csrf
              @method('PUT')
              <div class="card-body">
                @if ($errors->any())
                  <div class="alert alert-danger alert-dismissible">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h5><i class="icon fas fa-ban"></i> Validation Error!</h5>
                    @foreach ($errors->all() as $error)
                      <li>{{ $error }}</li>
                    @endforeach
                  </div>
                @endif
                @if (session()->has('message'))
                  <div class="alert {{ session('alert-type') }} alert-dismissible">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h5><i class="icon fas {{ session('check-circle') }}"></i> {{ session('message') }}</h5>
                  </div>
                @endif
                <div class="form-group">
                  <label for="name">Name</label>
                  <input type="text" class="form-control" value="{{ $city->name }}" name="name" id="name"
                    placeholder="Enter City Name">
                </div>
                <div class="form-group">
                  <div class="custom-control custom-switch">
                    <input type="checkbox" class="custom-control-input" name="active" id="active" @if ($city->active) checked @endif>
                    <label class="custom-control-label" for="active">Active Status</label>
                  </div>
                </div>
              </div>
              <!-- /.card-body -->
              <div class="card-footer">
                <button type="submit" class="btn btn-primary">Submit</button>
              </div>
            </form>
          </div>
          <!-- /.card -->
        </div>
        <!--/.col (left) -->
      </div>
      <!-- /.row -->
    </div><!-- /.container-fluid -->
  </section>
  <!-- /.content -->

@endsection

@section('scripts')

  <script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
  <script type="text/javascript">
    $(document).ready(function() {
      bsCustomFileInput.init();
    });

  </script>

@endsection

resources/views/cms/cities/index.blade.php
@extends('cms.parent')

@section('title', 'Cities')
@section('page-name', 'Index Cities')
@section('main-page', 'Cities')
@section('sub-page', 'Index')

@section('styles')
  <link href="{{ asset('css/tailWind.css') }}" rel="stylesheet">
@endsection



@section('content')
  <section class="content">
    <div class="container-fluid">
      <div class="row">
        <div class="col-12">
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">Cities</h3>

              <div class="card-tools">
                <div class="input-group input-group-sm" style="width: 150px;">
                  <input type="text" name="table_search" class="form-control float-right" placeholder="Search">

                  <div class="input-group-append">
                    <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
                  </div>
                </div>
              </div>
            </div>
            <!-- /.card-header -->
            <div class="card-body table-responsive p-0">
              <table class="table table-hover table-bordered text-nowrap">
                <thead>
                  <tr>
                    <th>#</th>
                    <th>Name</th>
                    <th>Active</th>
                    <th>Admins Count</th>
                    <th>Created At</th>
                    <th>Updated At</th>
                    <th>Settings</th>
                  </tr>
                </thead>
                <tbody>
                  @foreach ($cities as $city)
                    <tr>
                      <td>{{ $city->id }}</td>
                      <td>{{ $city->name }}</td>
                      <td><span @if ($city->active) class="badge bg-success" @else class="badge bg-danger" @endif>{{ $city->status }}</span></td>
                      <td><span class="badge bg-info">{{ $city->admins_count }} Admin/s</span></td>
                      <td>{{ $city->created_at->format('y-m-d') }}</td>
                      <td>{{ $city->updated_at->format('y-m-d') }}</td>
                      <td>
                        <div class="btn-group">
                          <a href="{{ route('cities.edit', $city->id) }}" class="btn btn-info"><i
                              class="fas fa-edit"></i></a>

                          {{-- <form method="POST" action="{{ route('cities.destroy', $city->id) }}">
                                          @csrf
                                          @method('DELETE')
                                          <button type="submit" class="btn btn-danger"><i class="fas fa-trash"></i></button>
                                        </form> --}}
                          <a href="#" class="btn btn-danger" onclick="confirmDestroy({{ $city->id }}, this)"><i
                              class="fas fa-trash"></i></a>
                        </div>
                      </td>
                    </tr>
                  @endforeach

                </tbody>
              </table>
            </div>
            <div class="card-footer clearfix">
              {{ $cities->links() }}
            </div>
            <!-- /.card-body -->
          </div>
          <!-- /.card -->
        </div>
      </div>
      <!-- /.row -->
    </div>
  </section>
@endsection

@section('scripts')

  <script>
    function confirmDestroy(id, td) {
      console.log('CITY ID : ' + id);
      Swal.fire({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
      }).then((result) => {
        if (result.isConfirmed) {
          destroy(id, td);
        }
      });
    }

    function destroy(id, td) {
      axios.delete('/cms/admin/cities/' + id)
        .then(function(response) {
          // handle success
          console.log(response);
          showAlert(response.data);
          td.closest('tr').remove();
        })
        .catch(function(error) {
          // handle error
          console.log(error);
          showAlert(error.response.data);
        })
        .then(function() {
          // always executed
        });
    }

    function showAlert(data) {
      let timerInterval
      Swal.fire({
        title: data.title,
        text: data.message,
        icon: data.icon,
        timer: 2000,
        showConfirmButton: false,
        timerProgressBar: false,
        didOpen: () => {
          // Swal.showLoading()
        },
        willClose: () => {
          clearInterval(timerInterval)
        }
      }).then((result) => {
        /* Read more about handling dismissals below */
        if (result.dismiss === Swal.DismissReason.timer) {
          console.log('I was closed by the timer')
        }
      })
    }

  </script>

@endsection